/**
* DO NOT EDIT THIS FILE.
* See the following change record for more information,
* https://www.drupal.org/node/2815083
* @preserve
**/

(function ($, Drupal, window) {
  Drupal.behaviors.checkPaymentState = {
    attach: function attach(context, settings) {
      var _settings$polling = settings.polling,
          payment_gateway = _settings$polling.payment_gateway,
          out_trade_no = _settings$polling.out_trade_no,
          interval = _settings$polling.interval,
          timeout = _settings$polling.timeout;


      function checkState() {
        $.ajax({
          url: Drupal.url('payment/state/' + payment_gateway + '/' + out_trade_no),
          type: 'POST',
          dataType: 'json',
          success: function success(data) {
            if (data.success) {
              clearInterval(polling);
              isTimeout = true;
              window.location.href = data.redirect;
            }
          }
        });
      }

      var polling = setInterval(checkState, +interval);
      var isTimeout = false;
      setTimeout(function () {
        clearInterval(polling);
        isTimeout = true;
      }, +timeout);

      var hidden = void 0,
          visibilityChange = void 0;
      if (typeof document.hidden !== 'undefined') {
        hidden = 'hidden';
        visibilityChange = 'visibilitychange';
      } else if (typeof document.msHidden !== 'undefined') {
        hidden = 'msHidden';
        visibilityChange = 'msvisibilitychange';
      } else if (typeof document.webkitHidden !== 'undefined') {
        hidden = 'webkitHidden';
        visibilityChange = 'webkitvisibilitychange';
      }

      function handleVisibilityChange() {
        if (isTimeout) {
          return;
        }
        if (document[hidden]) {
          clearInterval(polling);
        } else {
          clearInterval(polling);
          polling = setInterval(checkState, +interval);
        }
      }

      if (typeof document.addEventListener === 'undefined' || typeof document[hidden] === 'undefined') {
        console.warn('The browser does not support the Page Visibility API.');
      } else {
        document.addEventListener(visibilityChange, handleVisibilityChange, false);
      }
    },

    detach: function detach(context, settings, trigger) {}
  };
})(jQuery, Drupal, window);